package com.hai.dao;

import com.hai.entity.HighActivityAwardUser;
import com.hai.entity.HighActivityAwardUserExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighActivityAwardUserMapper extends HighActivityAwardUserMapperExt {
    @SelectProvider(type=HighActivityAwardUserSqlProvider.class, method="countByExample")
    long countByExample(HighActivityAwardUserExample example);

    @DeleteProvider(type=HighActivityAwardUserSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighActivityAwardUserExample example);

    @Delete({
        "delete from high_activity_award_user",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_activity_award_user (activity_info_id, activity_award_id, ",
        "activity_award_serial_num_id, user_id, ",
        "create_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{activityInfoId,jdbcType=BIGINT}, #{activityAwardId,jdbcType=BIGINT}, ",
        "#{activityAwardSerialNumId,jdbcType=BIGINT}, #{userId,jdbcType=BIGINT}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighActivityAwardUser record);

    @InsertProvider(type=HighActivityAwardUserSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighActivityAwardUser record);

    @SelectProvider(type=HighActivityAwardUserSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_award_id", property="activityAwardId", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_award_serial_num_id", property="activityAwardSerialNumId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighActivityAwardUser> selectByExample(HighActivityAwardUserExample example);

    @Select({
        "select",
        "id, activity_info_id, activity_award_id, activity_award_serial_num_id, user_id, ",
        "create_time, ext_1, ext_2, ext_3",
        "from high_activity_award_user",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_award_id", property="activityAwardId", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_award_serial_num_id", property="activityAwardSerialNumId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighActivityAwardUser selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighActivityAwardUserSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighActivityAwardUser record, @Param("example") HighActivityAwardUserExample example);

    @UpdateProvider(type=HighActivityAwardUserSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighActivityAwardUser record, @Param("example") HighActivityAwardUserExample example);

    @UpdateProvider(type=HighActivityAwardUserSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighActivityAwardUser record);

    @Update({
        "update high_activity_award_user",
        "set activity_info_id = #{activityInfoId,jdbcType=BIGINT},",
          "activity_award_id = #{activityAwardId,jdbcType=BIGINT},",
          "activity_award_serial_num_id = #{activityAwardSerialNumId,jdbcType=BIGINT},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighActivityAwardUser record);
}